package de.jottyfan.timetrack.config.converter;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.core.convert.converter.Converter;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.oauth2.jwt.Jwt;

/**
 * 
 * @author henkej
 * 
 */
public class KeycloakRealmRoleConverter implements Converter<Jwt, Collection<GrantedAuthority>> {
	@Override
	public Collection<GrantedAuthority> convert(Jwt jwt) {
		Object o = jwt.getClaims().get("realm_access");
		@SuppressWarnings("unchecked")
		final Map<String, Object> realmAccess = (Map<String, Object>) o;
		Object o2 = realmAccess.get("roles");
		@SuppressWarnings("unchecked")
		List<String> l = (List<String>) o2;
		return l.stream().map(roleName -> "ROLE_" + roleName).map(SimpleGrantedAuthority::new).collect(Collectors.toList());
	}
}